Index: src/train_cmd.cpp
===================================================================
--- src/train_cmd.cpp	(revision 13552)
+++ src/train_cmd.cpp	(working copy)
@@ -39,6 +39,7 @@
 #include "tunnelbridge_map.h"
 #include "strings_func.h"
 #include "functions.h"
+#include "sharedinfrastructure.h"
 #include "window_func.h"
 #include "date_func.h"
 #include "vehicle_func.h"
@@ -51,6 +52,7 @@
 #include "order_func.h"
 #include "newgrf_station.h"
 #include "effectvehicle_func.h"
+#include <stack>
 
 #include "table/strings.h"
 #include "table/train_cmd.h"
@@ -697,15 +699,22 @@
 	 * to the player. Doesn't matter if only the cost is queried */
 	if (!(flags & DC_QUERY_COST)) {
 		if (!IsRailDepotTile(tile)) return CMD_ERROR;
-		if (!IsTileOwner(tile, _current_player)) return CMD_ERROR;
+		if (!IsTileOwner(tile, _current_player) && !SharedRailwayDepots(tile, _current_player)) return CMD_ERROR;
 	}
 
 	const RailVehicleInfo *rvi = RailVehInfo(p1);
 
-	if (rvi->railveh_type == RAILVEH_WAGON) return CmdBuildRailWagon(p1, tile, flags);
+	CommandCost value;
+	if (rvi->railveh_type == RAILVEH_WAGON) {
+		value = CmdBuildRailWagon(p1, tile, flags);
+		SharedDepotProvision(value, GetTileOwner(tile), flags);
 
-	CommandCost value = EstimateTrainCost(p1, rvi);
+		return value;
+	}
 
+	value = EstimateTrainCost(p1, rvi);
+
+
 	uint num_vehicles =
 		(rvi->railveh_type == RAILVEH_MULTIHEAD ? 2 : 1) +
 		CountArticulatedParts(p1, false);
@@ -812,7 +821,7 @@
 			GetPlayer(_current_player)->num_engines[p1]++;
 		}
 	}
-
+	SharedDepotProvision(value, GetTileOwner(tile), flags);
 	return value;
 }
 
@@ -1290,7 +1299,7 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	if (v->type != VEH_TRAIN || !IsTileOwner(tile, _current_player)) return CMD_ERROR;
 
 	/* Check if this train can be started/stopped. The callback will fail or
 	 * return 0xFF if it can. */
@@ -1858,7 +1867,8 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	/* In order to sort out jams on your tracks you have to be able to turn trains */
+	if (v->type != VEH_TRAIN || !IsTileOwner(tile, _current_player)) return CMD_ERROR;
 
 	if (p2 != 0) {
 		/* turn a single unit around */
@@ -1907,7 +1917,10 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	/** A track owner must stay in control of his tracks so others cannot 
+	 *  produce forcefully crashes there
+	 */
+	if (v->type != VEH_TRAIN || !IsTileOwner(tile, _current_player)) return CMD_ERROR;
 
 	if (flags & DC_EXEC) v->u.rail.force_proceed = 0x50;
 
@@ -2731,7 +2744,8 @@
 static inline bool CheckCompatibleRail(const Vehicle *v, TileIndex tile)
 {
 	return
-		IsTileOwner(tile, v->owner) && (
+		(IsTileOwner(tile, v->owner) || 
+			(SharedTracks(tile, v->owner))) && (
 			!IsFrontEngine(v) ||
 			HasBit(v->u.rail.compatible_railtypes, GetRailType(tile))
 		);
@@ -3623,7 +3637,6 @@
 					v->index,
 					0);
 			}
-
 			v->profit_last_year = v->profit_this_year;
 			v->profit_this_year = 0;
 			InvalidateWindow(WC_VEHICLE_DETAILS, v->index);
Index: src/command.cpp
===================================================================
--- src/command.cpp	(revision 13552)
+++ src/command.cpp	(working copy)
@@ -198,6 +198,9 @@
 DEF_COMMAND(CmdChangeTimetable);
 DEF_COMMAND(CmdSetVehicleOnTime);
 DEF_COMMAND(CmdAutofillTimetable);
+
+DEF_COMMAND(CmdSetSharedBoolValues);
+DEF_COMMAND(CmdSetSharedIntValues);
 #undef DEF_COMMAND
 
 /**
@@ -346,6 +349,9 @@
 	{CmdChangeTimetable,                     0}, /* CMD_CHANGE_TIMETABLE */
 	{CmdSetVehicleOnTime,                    0}, /* CMD_SET_VEHICLE_ON_TIME */
 	{CmdAutofillTimetable,                   0}, /* CMD_AUTOFILL_TIMETABLE */
+
+	{CmdSetSharedBoolValues,                 0}, /* CMD_SET_SHARED_BOOL_VALUES */
+	{CmdSetSharedIntValues,                  0}, /* CMD_SET_SHARED_INT_VALUES */
 };
 
 /*!
Index: src/player_base.h
===================================================================
--- src/player_base.h	(revision 13552)
+++ src/player_base.h	(working copy)
@@ -71,6 +71,26 @@
 	int16 engine_renew_months;
 	uint32 engine_renew_money;
 	uint16 *num_engines; ///< caches the number of engines of each type the player owns (no need to save this)
+
+	/** Shared infrastructure
+	 * first element is actual value
+	 * second is value to be set at end of shared_change_months counter
+	 * (see patch value of shared_delay)
+	 */
+	bool shared_railway_tracks[2];
+	bool shared_railway_stations[2];
+	bool shared_railway_depots[2];
+	uint16 shared_tontile_cost[2];
+	uint8 shared_road_stops_fee[2];
+	uint8 shared_harbours_fee[2];
+	bool shared_airports[2];
+	uint16 shared_landing_fee[2];
+	bool shared_road_depots[2];
+	bool shared_road_stops[2];
+	bool shared_water_depots[2];
+	bool shared_harbours[2];
+	uint8 shared_provision[2];
+	uint8 shared_change_months;
 };
 
 struct PlayerMoneyBackup {
Index: src/settings_type.h
===================================================================
--- src/settings_type.h	(revision 13552)
+++ src/settings_type.h	(working copy)
@@ -304,6 +304,25 @@
 	byte   station_spread;                   ///< amount a station may spread
 };
 
+ /** Shared Infrastructure **/
+struct SharingSettings {
+  	bool shared_railway_stations;          ///< allow railway stations sharing
+  	bool shared_railway_tracks;            ///< allow railway tracks sharing
+  	bool shared_railway_depots;            ///< allow railway depots sharing
+  	bool shared_road_depots;               ///< allow road depots sharing
+  	bool shared_road_stops;                ///< allow road stops sharing
+  	bool shared_water_depots;              ///< allow water depots sharing
+  	bool shared_harbours;                  ///< allow harbours sharing
+  	bool shared_airports;                  ///< allow airports sharing
+  	int8 shared_provision;                 ///< default value for depots provision (buy cost %)
+  	uint16 shared_tontile_cost;            ///< default value for tracks sharing payment (per 1000 tons per tiles)
+  	uint16 shared_landing_fee;             ///< default value for airports landing fee (per tons of cargo capacity)
+  	int8 shared_road_stops_fee;            ///< default value for entering road stops (per tons of cargo capacity)
+  	int8 shared_harbours_fee;              ///< default value for entering harbours (per tons of cargo capacity)
+  	bool shared_player_level;              ///< allow players to set individual sharing settings
+  	uint8 shared_delay;                    ///< delay before activating individual sharing settings 
+};  
+
 /** All settings together for the game. */
 struct GameSettings {
 	DifficultySettings   difficulty;         ///< settings related to the difficulty
@@ -315,6 +334,7 @@
 	VehicleSettings      vehicle;            ///< options for vehicles
 	EconomySettings      economy;            ///< settings to change the economy
 	StationSettings      station;            ///< settings related to station management
+ 	SharingSettings		 sharing;            ///< settings related to infrastructure sharing
 	LocaleSettings       locale;             ///< settings related to used currency/unit system in the current game
 };
 
Index: src/depot_gui.cpp
===================================================================
--- src/depot_gui.cpp	(revision 13552)
+++ src/depot_gui.cpp	(working copy)
@@ -27,6 +27,7 @@
 #include "tilehighlight_func.h"
 #include "window_gui.h"
 #include "vehiclelist.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -314,7 +315,7 @@
 		uint16 boxes_in_each_row = this->widget[DEPOT_WIDGET_MATRIX].data & 0xFF;
 
 		/* setup disabled buttons */
-		this->SetWidgetsDisabledState(!IsTileOwner(tile, _local_player),
+		this->SetWidgetsDisabledState(!IsTileOwner(tile, _local_player) && !SharedDepotVehicleType(tile,_local_player, this->type),
 			DEPOT_WIDGET_STOP_ALL,
 			DEPOT_WIDGET_START_ALL,
 			DEPOT_WIDGET_SELL,
Index: src/command_type.h
===================================================================
--- src/command_type.h	(revision 13552)
+++ src/command_type.h	(working copy)
@@ -278,6 +278,8 @@
 	CMD_CHANGE_TIMETABLE,             ///< change the timetable for a vehicle
 	CMD_SET_VEHICLE_ON_TIME,          ///< set the vehicle on time feature (timetable)
 	CMD_AUTOFILL_TIMETABLE,           ///< autofill the timetable
+	CMD_SET_SHARED_BOOL_VALUES,       ///< set shared infrastructure player bool value
+	CMD_SET_SHARED_INT_VALUES,        ///< set shared infrastructure player int value
 };
 
 /**
Index: src/order_gui.cpp
===================================================================
--- src/order_gui.cpp	(revision 13552)
+++ src/order_gui.cpp	(working copy)
@@ -31,6 +31,7 @@
 #include "string_func.h"
 #include "depot_base.h"
 #include "tilehighlight_func.h"
+#include "sharedinfrastructure.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -271,7 +272,7 @@
 	if (_settings_game.order.gotodepot) {
 		switch (GetTileType(tile)) {
 			case MP_RAILWAY:
-				if (v->type == VEH_TRAIN && IsTileOwner(tile, _local_player)) {
+ 				if (v->type == VEH_TRAIN && (IsTileOwner(tile, _local_player) || SharedRailwayDepots(tile, _local_player))) {
 					if (IsRailDepot(tile)) {
 						order.MakeGoToDepot(GetDepotByTile(tile)->index, ODTFB_PART_OF_ORDERS);
 						if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
@@ -281,7 +282,7 @@
 				break;
 
 			case MP_ROAD:
-				if (IsRoadDepot(tile) && v->type == VEH_ROAD && IsTileOwner(tile, _local_player)) {
+				if (IsRoadDepot(tile) && v->type == VEH_ROAD && (IsTileOwner(tile, _local_player) || SharedRoadDepots(tile, _local_player))) {
 					order.MakeGoToDepot(GetDepotByTile(tile)->index, ODTFB_PART_OF_ORDERS);
 					if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
 					return order;
@@ -290,7 +291,7 @@
 
 			case MP_STATION:
 				if (v->type != VEH_AIRCRAFT) break;
-				if (IsHangar(tile) && IsTileOwner(tile, _local_player)) {
+				if (IsHangar(tile) && (IsTileOwner(tile, _local_player) || SharedAirports(tile, _local_player))) {
 					order.MakeGoToDepot(GetStationIndex(tile), ODTFB_PART_OF_ORDERS);
 					return order;
 				}
@@ -298,9 +299,8 @@
 
 			case MP_WATER:
 				if (v->type != VEH_SHIP) break;
-				if (IsShipDepot(tile) && IsTileOwner(tile, _local_player)) {
+				if (IsShipDepot(tile) && (IsTileOwner(tile, _local_player)||SharedWaterDepots(tile, _local_player))) {
 					TileIndex tile2 = GetOtherShipDepotTile(tile);
-
 					order.MakeGoToDepot(GetDepotByTile(tile < tile2 ? tile : tile2)->index, ODTFB_PART_OF_ORDERS);
 					return order;
 				}
@@ -313,7 +313,7 @@
 	/* check waypoint */
 	if (IsTileType(tile, MP_RAILWAY) &&
 			v->type == VEH_TRAIN &&
-			IsTileOwner(tile, _local_player) &&
+			(IsTileOwner(tile, _local_player)||SharedTracks(tile, _local_player)) &&
 			IsRailWaypoint(tile)) {
 		order.MakeGoToWaypoint(GetWaypointByTile(tile)->index);
 		if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
@@ -324,19 +324,22 @@
 		StationID st_index = GetStationIndex(tile);
 		const Station *st = GetStation(st_index);
 
-		if (st->owner == _current_player || st->owner == OWNER_NONE) {
 			byte facil;
 			(facil = FACIL_DOCK, v->type == VEH_SHIP) ||
 			(facil = FACIL_TRAIN, v->type == VEH_TRAIN) ||
 			(facil = FACIL_AIRPORT, v->type == VEH_AIRCRAFT) ||
 			(facil = FACIL_BUS_STOP, v->type == VEH_ROAD && IsCargoInClass(v->cargo_type, CC_PASSENGERS)) ||
 			(facil = FACIL_TRUCK_STOP, 1);
-			if (st->facilities & facil) {
-				order.MakeGoToStation(st_index);
-				if (_settings_client.gui.new_nonstop && (v->type == VEH_TRAIN || v->type == VEH_ROAD)) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
-				return order;
+			if(((facil==FACIL_DOCK) && ((st->owner == _current_player) || SharedHarbours(tile, _current_player))) ||
+  			   ((facil==FACIL_TRAIN) && ((st->owner == _current_player) || SharedRailwayStations(tile, _current_player))) ||
+  			   ((facil==FACIL_AIRPORT) && ((st->owner == _current_player) || SharedAirports(tile, _current_player))) ||
+  			   (((facil==FACIL_BUS_STOP)||(facil==FACIL_TRUCK_STOP)) && ((st->owner == _current_player) || SharedRoadStops(tile, _current_player)))) {
+  					if (st->facilities & facil) {
+  						order.MakeGoToStation(st_index);
+  						if (_settings_client.gui.new_nonstop && (v->type == VEH_TRAIN || v->type == VEH_ROAD)) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
+  						return order;
+  					}
 			}
-		}
 	}
 
 	/* not found */
Index: src/cargopacket.h
===================================================================
--- src/cargopacket.h	(revision 13552)
+++ src/cargopacket.h	(working copy)
@@ -7,6 +7,7 @@
 
 #include "oldpool.h"
 #include "economy_type.h"
+#include "player_type.h"
 #include "tile_type.h"
 #include "station_type.h"
 #include <list>
@@ -24,7 +25,7 @@
  * Container for cargo from the same location and time
  */
 struct CargoPacket : PoolItem<CargoPacket, CargoPacketID, &_CargoPacket_pool> {
-	Money feeder_share;     ///< Value of feeder pickup to be paid for on delivery of cargo
+	Money feeder_share[MAX_PLAYERS];     ///< Value of feeder pickup to be paid for on delivery of cargo
 	TileIndex source_xy;    ///< The origin of the cargo (first station in feeder chain)
 	TileIndex loaded_at_xy; ///< Location where this cargo has been loaded into the vehicle
 	StationID source;       ///< The station where the cargo came from first
Index: src/economy.cpp
===================================================================
--- src/economy.cpp	(revision 13552)
+++ src/economy.cpp	(working copy)
@@ -45,6 +45,7 @@
 #include "gfx_func.h"
 #include "autoreplace_func.h"
 #include "player_gui.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -383,6 +384,8 @@
 					DeleteWindowById(WC_VEHICLE_VIEW, v->index);
 					DeleteWindowById(WC_VEHICLE_DETAILS, v->index);
 					DeleteWindowById(WC_VEHICLE_ORDERS, v->index);
+					/* clean shared infrastructure */
+					UpdateSharedOnRemove(v->index);
 
 					if (v->IsPrimaryVehicle() || (v->type == VEH_TRAIN && IsFreeWagon(v))) {
 						switch (v->type) {
@@ -392,7 +395,11 @@
 								Vehicle *u = v;
 								do {
 									Vehicle *next = GetNextVehicle(u);
+									TileIndex old_tile = v->tile;
+									DiagDirection old_dir = DirToDiagDir(v->direction);
 									delete u;
+									/* now that vehicle is removed, clear signal */
+									UpdateSignalsOnSegment(old_tile, old_dir, GetTileOwner(old_tile));
 									u = next;
 								} while (u != NULL);
 							} break;
@@ -423,6 +430,12 @@
 			}
 		}
 	}
+	
+	/** take care of other players vehicles on bankrupt company's shared structure
+	 * at this point, there should be no vehicle left to old_player */
+	if (new_player == PLAYER_SPECTATOR) {
+		OnSharedClose(old_player, SHARED_ALL);
+	}
 
 	/*  Change ownership of tiles */
 	{
@@ -1362,8 +1375,10 @@
 	int result = 0;
 
 	Money vehicle_profit = 0; // Money paid to the train
-	Money route_profit   = 0; // The grand total amount for the route. A-D of transfer chain A-B-C-D
+	Money route_profit[MAX_PLAYERS] = {0};  // The grand total amount for the route. A-D of transfer chain A-B-C-D
+	bool route_profit_change = false;
 	Money virtual_profit = 0; // The virtual profit for entire vehicle chain
+	const Player* p;
 
 	StationID last_visited = front_v->last_station_visited;
 	Station *st = GetStation(last_visited);
@@ -1403,8 +1418,13 @@
 				/* handle end of route payment */
 				Money profit = DeliverGoods(cp->count, v->cargo_type, cp->source, last_visited, cp->source_xy, cp->days_in_transit);
 				cp->paid_for = true;
-				route_profit   += profit; // display amount paid for final route delivery, A-D of a chain A-B-C-D
-				vehicle_profit += profit - cp->feeder_share;                    // whole vehicle is not payed for transfers picked up earlier
+				FOR_ALL_PLAYERS(p) {   // display amount paid for final route delivery, A-D of a chain A-B-C-D
+					route_profit[p->index] += cp->feeder_share[p->index];
+					profit -= cp->feeder_share[p->index]; // whole vehicle is not payed for transfers picked up earlier
+				}
+				route_profit[v->owner] += profit;
+				vehicle_profit += profit;
+				route_profit_change = true;
 
 				result |= 1;
 
@@ -1420,7 +1440,7 @@
 
 					front_v->profit_this_year += profit << 8;
 					virtual_profit   += profit; // accumulate transfer profits for whole vehicle
-					cp->feeder_share += profit; // account for the (virtual) profit already made for the cargo packet
+					cp->feeder_share[front_v->owner] += profit; // account for the (virtual) profit already made for the cargo packet
 					cp->paid_for      = true;   // record that the cargo has been paid for to eliminate double counting
 				}
 				result |= 2;
@@ -1435,9 +1455,13 @@
 		ShowFeederIncomeAnimation(front_v->x_pos, front_v->y_pos, front_v->z_pos, virtual_profit);
 	}
 
-	if (route_profit != 0) {
+	if (route_profit_change) {
 		front_v->profit_this_year += vehicle_profit << 8;
-		SubtractMoneyFromPlayer(CommandCost(front_v->GetExpenseType(true), -route_profit));
+		FOR_ALL_PLAYERS(p) {
+			_current_player = p->index;
+			SubtractMoneyFromPlayer(CommandCost(front_v->GetExpenseType(true), -route_profit[p->index]));
+		}
+		_current_player = front_v->owner;
 
 		if (IsLocalPlayer() && !PlayVehicleSound(front_v, VSE_LOAD_UNLOAD)) {
 			SndPlayVehicleFx(SND_14_CASHTILL, front_v);
Index: src/news_gui.cpp
===================================================================
--- src/news_gui.cpp	(revision 13552)
+++ src/news_gui.cpp	(working copy)
@@ -133,6 +133,7 @@
 	{ NT_COMPANY_INFO,    NM_NORMAL,   NF_NONE,                DrawNewsBankrupcy       }, ///< NS_COMPANY_BANKRUPT
 	{ NT_COMPANY_INFO,    NM_NORMAL,   NF_TILE,                DrawNewsBankrupcy       }, ///< NS_COMPANY_NEW
 	{ NT_OPENCLOSE,       NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_OPENCLOSE
+	{ NT_COMPANY_INFO,    NM_NORMAL,   NF_VIEWPORT | NF_TILE,  NULL                    }, ///< NS_COMPANY_SHARING
 	{ NT_ECONOMY,         NM_NORMAL,   NF_NONE,                NULL                    }, ///< NS_ECONOMY
 	{ NT_INDUSTRY_PLAYER, NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_INDUSTRY_PLAYER
 	{ NT_INDUSTRY_OTHER,  NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_INDUSTRY_OTHER
Index: src/cargopacket.cpp
===================================================================
--- src/cargopacket.cpp	(revision 13552)
+++ src/cargopacket.cpp	(working copy)
@@ -8,6 +8,7 @@
 #include "cargopacket.h"
 #include "saveload.h"
 #include "oldpool_func.h"
+#include "player_base.h"
 
 /* Initialize the cargopacket-pool */
 DEFINE_OLD_POOL_GENERIC(CargoPacket, CargoPacket)
@@ -21,6 +22,8 @@
 
 CargoPacket::CargoPacket(StationID source, uint16 count)
 {
+	const Player* p;
+
 	if (source != INVALID_STATION) assert(count != 0);
 
 	this->source          = source;
@@ -29,7 +32,8 @@
 
 	this->count           = count;
 	this->days_in_transit = 0;
-	this->feeder_share    = 0;
+	FOR_ALL_PLAYERS(p)
+		this->feeder_share[p->index]= 0;
 	this->paid_for        = false;
 }
 
@@ -49,7 +53,8 @@
 	SLE_VAR(CargoPacket, loaded_at_xy,    SLE_UINT32),
 	SLE_VAR(CargoPacket, count,           SLE_UINT16),
 	SLE_VAR(CargoPacket, days_in_transit, SLE_UINT8),
-	SLE_VAR(CargoPacket, feeder_share,    SLE_INT64),
+	SLE_CONDVAR(CargoPacket, feeder_share[0], SLE_INT64, 0, 95),
+	SLE_CONDARR(CargoPacket, feeder_share,    SLE_INT64, MAX_PLAYERS, 95, SL_MAX_VERSION),
 	SLE_VAR(CargoPacket, paid_for,        SLE_BOOL),
 
 	SLE_END()
@@ -142,13 +147,16 @@
 
 void CargoList::Append(CargoPacket *cp)
 {
+	const Player* p;
+
 	assert(cp != NULL);
 	assert(cp->IsValid());
 
 	for (List::iterator it = packets.begin(); it != packets.end(); it++) {
 		if ((*it)->SameSource(cp) && (*it)->count + cp->count <= 65535) {
 			(*it)->count        += cp->count;
-			(*it)->feeder_share += cp->feeder_share;
+			FOR_ALL_PLAYERS(p)
+				(*it)->feeder_share[p->index] += cp->feeder_share[p->index];
 			delete cp;
 
 			InvalidateCache();
@@ -189,6 +197,7 @@
 {
 	assert(mta == MTA_FINAL_DELIVERY || dest != NULL);
 	CargoList tmp;
+	const Player* p;
 
 	while (!packets.empty() && count > 0) {
 		CargoPacket *cp = *packets.begin();
@@ -223,14 +232,16 @@
 				cp_new->loaded_at_xy    = (mta == MTA_CARGO_LOAD) ? data : cp->loaded_at_xy;
 
 				cp_new->days_in_transit = cp->days_in_transit;
-				cp_new->feeder_share    = cp->feeder_share / count;
+				FOR_ALL_PLAYERS(p)
+					cp_new->feeder_share[p->index] = cp->feeder_share[p->index] / count;
 				/* When cargo is moved into another vehicle you have *always* paid for it */
 				cp_new->paid_for        = (mta == MTA_CARGO_LOAD) ? false : cp->paid_for;
 
 				cp_new->count = count;
 				dest->packets.push_back(cp_new);
 
-				cp->feeder_share /= cp->count - count;
+				FOR_ALL_PLAYERS(p)
+					cp->feeder_share[p->index] /= cp->count - count;
 			}
 			cp->count -= count;
 
@@ -260,6 +271,7 @@
 	feeder_share = 0;
 	source = INVALID_STATION;
 	days_in_transit = 0;
+	const Player* p;
 
 	if (empty) return;
 
@@ -268,7 +280,8 @@
 		count        += (*it)->count;
 		unpaid_cargo |= !(*it)->paid_for;
 		dit          += (*it)->days_in_transit * (*it)->count;
-		feeder_share += (*it)->feeder_share;
+		FOR_ALL_PLAYERS(p)
+			feeder_share += (*it)->feeder_share[p->index];
 	}
 	days_in_transit = dit / count;
 	source = (*packets.begin())->source;
Index: src/vehicle_gui.cpp
===================================================================
--- src/vehicle_gui.cpp	(revision 13552)
+++ src/vehicle_gui.cpp	(working copy)
@@ -1846,16 +1846,17 @@
 		const Vehicle *v = GetVehicle(this->window_number);
 		StringID str;
 		bool is_localplayer = v->owner == _local_player;
+		TileIndex tile = v->tile;
+		bool is_trackowner  = IsTileOwner(tile,_local_player);
 		bool refitable_and_stopped_in_depot = IsVehicleRefitable(v);
 
 		this->SetWidgetDisabledState(VVW_WIDGET_GOTO_DEPOT, !is_localplayer);
-		this->SetWidgetDisabledState(VVW_WIDGET_REFIT_VEH,
-																!refitable_and_stopped_in_depot || !is_localplayer);
+		this->SetWidgetDisabledState(VVW_WIDGET_REFIT_VEH, !refitable_and_stopped_in_depot || !is_localplayer);
 		this->SetWidgetDisabledState(VVW_WIDGET_CLONE_VEH, !is_localplayer);
 
 		if (v->type == VEH_TRAIN) {
-			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !is_localplayer);
-			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !is_localplayer);
+			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !is_trackowner);
+			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !is_trackowner);
 
 			/* Cargo refit button is disabled, until we know we can enable it below. */
 
Index: src/pathfind.cpp
===================================================================
--- src/pathfind.cpp	(revision 13552)
+++ src/pathfind.cpp	(working copy)
@@ -17,6 +17,7 @@
 #include "core/random_func.hpp"
 #include "core/alloc_type.hpp"
 #include "tunnelbridge.h"
+#include "sharedinfrastructure.h"
 
 /* remember which tiles we have already visited so we don't visit them again. */
 static bool TPFSetTileBit(TrackPathFinder *tpf, TileIndex tile, int dir)
Index: src/yapf/follow_track.hpp
===================================================================
--- src/yapf/follow_track.hpp	(revision 13552)
+++ src/yapf/follow_track.hpp	(working copy)
@@ -6,7 +6,9 @@
 #define  FOLLOW_TRACK_HPP
 
 #include "yapf.hpp"
+#include "../rail_map.h"
 #include "../depot_map.h"
+#include "../sharedinfrastructure.h"
 
 /** Track follower helper template class (can serve pathfinders and vehicle
  *  controllers). See 6 different typedefs below for 3 different transport
@@ -217,12 +219,13 @@
 				return false;
 			}
 		}
-
-		/* single tram bits can only be entered from one direction */
-		DiagDirection single_tram = GetSingleTramBit(m_new_tile);
-		if (single_tram != INVALID_DIAGDIR && single_tram != ReverseDiagDir(m_exitdir)) {
-			m_err = EC_NO_WAY;
-			return false;
+		
+		// waypoints are not accessible to other companies
+		if ( IsTileType(m_new_tile, MP_RAILWAY) && IsRailTT() && (GetTileOwner(m_new_tile) != m_veh->owner)) {
+			if (GetRailTileType(m_new_tile) == RAIL_TILE_WAYPOINT) {
+				m_err = EC_NO_WAY;
+				return false;
+			}
 		}
 
 		// road and rail depots can also be entered from one direction only
@@ -233,25 +236,35 @@
 				return false;
 			}
 			// don't try to enter other player's depots
-			if (GetTileOwner(m_new_tile) != m_veh->owner) {
+			if ((GetTileOwner(m_new_tile) != m_veh->owner)&&(!SharedRoadDepots(m_new_tile,m_veh->owner))) {
 				m_err = EC_OWNER;
 				return false;
 			}
 		}
 		if (IsRailTT() && IsDepotTypeTile(m_new_tile, TT())) {
 			DiagDirection exitdir = GetRailDepotDirection(m_new_tile);
-			if (ReverseDiagDir(exitdir) != m_exitdir) {
+			if ((ReverseDiagDir(exitdir) != m_exitdir)||
+					(((GetTileOwner(m_new_tile) != m_veh->owner)&&
+					  (!SharedRailwayDepots(m_new_tile,m_veh->owner))))) {
 				m_err = EC_NO_WAY;
 				return false;
 			}
 		}
 
 		// rail transport is possible only on tiles with the same owner as vehicle
-		if (IsRailTT() && GetTileOwner(m_new_tile) != m_veh->owner) {
+		if (IsRailTT() && (GetTileOwner(m_new_tile) != m_veh->owner) &&
+				(GetTileOwner(m_old_tile) != GetTileOwner(m_new_tile)) && (!SharedTracks(m_new_tile,m_veh->owner))) {
 			// different owner
 			m_err = EC_NO_WAY;
 			return false;
 		}
+		
+		/* single tram bits can only be entered from one direction */
+		DiagDirection single_tram = GetSingleTramBit(m_new_tile);
+		if (single_tram != INVALID_DIAGDIR && single_tram != ReverseDiagDir(m_exitdir)) {
+			m_err = EC_NO_WAY;
+			return false;
+		}
 
 		// rail transport is possible only on compatible rail types
 		if (IsRailTT()) {
@@ -286,6 +299,11 @@
 
 		// special handling for rail stations - get to the end of platform
 		if (IsRailTT() && m_is_station) {
+			if((GetTileOwner(m_new_tile) != m_veh->owner) && (!SharedRailwayStations(m_new_tile,m_veh->owner)))
+			{
+				m_err = EC_NO_WAY;
+				return false;
+			}
 			// entered railway station
 			// get platform length
 			uint length = GetStationByTile(m_new_tile)->GetPlatformLength(m_new_tile, TrackdirToExitdir(m_old_td));
Index: src/players.cpp
===================================================================
--- src/players.cpp	(revision 13552)
+++ src/players.cpp	(working copy)
@@ -241,13 +241,15 @@
 	if (HasBit(1 << EXPENSES_TRAIN_INC    |
 	           1 << EXPENSES_ROADVEH_INC  |
 	           1 << EXPENSES_AIRCRAFT_INC |
-	           1 << EXPENSES_SHIP_INC, cost.GetExpensesType())) {
+	           1 << EXPENSES_SHIP_INC |
+	           1 << EXPENSES_SHARED_INF_INC, cost.GetExpensesType())) {
 		p->cur_economy.income -= cost.GetCost();
 	} else if (HasBit(1 << EXPENSES_TRAIN_RUN    |
 	                  1 << EXPENSES_ROADVEH_RUN  |
 	                  1 << EXPENSES_AIRCRAFT_RUN |
 	                  1 << EXPENSES_SHIP_RUN     |
 	                  1 << EXPENSES_PROPERTY     |
+	                  1 << EXPENSES_SHARED_INF_RUN |
 	                  1 << EXPENSES_LOAN_INT, cost.GetExpensesType())) {
 		p->cur_economy.expenses -= cost.GetCost();
 	}
@@ -558,6 +560,21 @@
 	free(p->num_engines);
 	p->num_engines = CallocT<uint16>(GetEnginePoolSize());
 
+	p->shared_railway_tracks[0] = p->shared_railway_tracks[1] =_settings_game.sharing.shared_railway_tracks;
+	p->shared_railway_stations[0] = p->shared_railway_stations[1] = _settings_game.sharing.shared_railway_stations;
+	p->shared_railway_depots[0] = p->shared_railway_depots[1] = _settings_game.sharing.shared_railway_depots;
+	p->shared_tontile_cost[0] = p->shared_tontile_cost[1] = _settings_game.sharing.shared_tontile_cost;
+	p->shared_road_stops_fee[0] = p->shared_road_stops_fee[1] = 0; // no limit
+	p->shared_harbours_fee[0] = p->shared_harbours_fee[1] = 0; // no limit
+	p->shared_airports[0] = p->shared_airports[1] = _settings_game.sharing.shared_airports;
+	p->shared_landing_fee[0] = p->shared_landing_fee[1] = _settings_game.sharing.shared_landing_fee;
+	p->shared_road_depots[0] = p->shared_road_depots[1] = _settings_game.sharing.shared_road_depots;
+	p->shared_road_stops[0] = p->shared_road_stops[1] = _settings_game.sharing.shared_road_stops;
+	p->shared_water_depots[0] = p->shared_water_depots[1] = _settings_game.sharing.shared_water_depots;
+	p->shared_harbours[0] = p->shared_harbours[1] = _settings_game.sharing.shared_harbours;
+	p->shared_provision[0] = p->shared_provision[1] = _settings_game.sharing.shared_provision;
+	p->shared_change_months = 0;
+
 	return p;
 }
 
@@ -1184,6 +1201,21 @@
 	SLE_CONDVAR(Player, engine_renew_money,    SLE_UINT32,                 16, SL_MAX_VERSION),
 	SLE_CONDVAR(Player, renew_keep_length,     SLE_BOOL,                    2, SL_MAX_VERSION), // added with 16.1, but was blank since 2
 
+	SLE_CONDARR(Player, shared_railway_tracks,   SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_railway_stations, SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_railway_depots,   SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_airports,         SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_road_depots,      SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_road_stops,       SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_water_depots,     SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_harbours,         SLE_BOOL,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_tontile_cost,     SLE_INT16, 2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_road_stops_fee,   SLE_INT8,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_harbours_fee,     SLE_INT8,  2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_landing_fee,      SLE_INT16, 2,                96, SL_MAX_VERSION),
+	SLE_CONDARR(Player, shared_provision,        SLE_INT8,  2,                96, SL_MAX_VERSION),
+	SLE_CONDVAR(Player, shared_change_months,    SLE_INT8,                    96, SL_MAX_VERSION),
+
 	/* reserve extra space in savegame here. (currently 63 bytes) */
 	SLE_CONDNULL(63, 2, SL_MAX_VERSION),
 
